// cds_WinAPI.inc (c) 2006 Campanile Data Services - All Rights Reserved
//
// The information contained herein comes mostly from MSDN and is
// considered reliable, but its accuracy is not warranted.
//
// Last update 5/26/06.

#ifndef CDS_WINAPI
#define CDS_WINAPI

declare import, BitBlt(
	unsigned int hdcDest,	// handle to destination DC
	int nXDest,						// x-coord of destination upper-left corner
	int nYDest,						// y-coord of destination upper-left corner
	int nWidth,						// width of destination rectangle
	int nHeight,					// height of destination rectangle
	unsigned int hdcSrc,	// handle to source DC
	int nXSrc,						// x-coordinate of source upper-left corner
	int nYSrc,						// y-coordinate of source upper-left corner
	unsigned int dwRop		// raster operation code
), int;									// returns 0 if function fails

declare import, CloseClipboard(),int; // returns 0 if function fails

declare import, CreateCompatibleDC(
	unsigned int hDC		// handle to an existing DC
), unsigned int;			// returns handle to memory DC, NULL if function fails

declare import, CreateCompatibleBitmap(
  unsigned int hdc,   // handle to DC
  int nWidth,         // width of bitmap, in pixels
  int nHeight         // height of bitmap, in pixels
), unsigned int;			// returns handle to bitmap, NULL if function fails

declare import, CreateFontIndirectA(
	LOGFONT *lf					// pointer to a logfont structure
), unsigned int;				// returns handle to logical font, NULL if function fails

declare import, CreatePen(
  int fnPenStyle, 	   	// pen style
  int nWidth,       	 	// pen width
  int crColor   				// pen color
), unsigned int;				// returns handle to logical pen, NULL if function fails

declare import, CreateRectRgnIndirect(
RECT *lprc							// pointer to rect structure
), unsigned int;				// returns handle to region, NULL if function fails

declare import, CreateSolidBrush(
	color as unsigned int	// brush color value
), unsigned int;				// handle to logical brush, NULL if function fails

declare import, CreateWindowExA(
	dwExStyle as unsigned INT,
	lpClassName  as string,
  lpWindowName as string,
  int dwStyle,
  int x, 
	int y,
  int nWidth,
  int nHeight,
  int hWndParent,
  hMenu as unsigned int,
  hInstance as unsigned int,
  lpParam as pointer
		), int;						// returns handle to new window, NULL if function fails

declare import, DeleteObject(
  unsigned int hObject		// handle to graphic object
), int;										// returns 0 if function fails

declare import, DrawTextA(
  unsigned int hDC,				// handle to DC
  string lpString,				// text to draw
  int nCount,							// text length
  rect *lpRect,						// formatting dimensions
  unsigned int uFormat		// text-drawing options
), int; 									// If the function succeeds, the return value is the height 
													// of the text in logical units. If DT_VCENTER or DT_BOTTOM is specified, 
													// the return value is the offset from lpRect->top to the bottom of the drawn text.
													// returns 0 if function fails

declare import,EllipseA alias Ellipse(
	hdc     as unsigned int,	// handle to DC
	nLeft   as int,						// x-coord of upper-left corner of rectangle
	nTop    as int,						// y-coord of upper-left corner of rectangle
	nRight  as int,						// x-coord of lower-right corner of rectangle				
	nBottom as int						// y-coord of lower-right corner of rectangle
), int;											// if the function fails, the return value is zero. 

declare import, EmptyClipboard(),int; // returns 0 if function fails

declare import, ExtFloodFill(
  unsigned int hdc,					// handle to DC
  int nXStart,							// starting x-coordinate 
  int nYStart,							// starting y-coordinate 
  unsigned int crColor,			// fill color
  unsigned int fuFillType		// fill type
), int;											// returns 0 if function fails

declare import, FillRect(
  unsigned int hDC,				// handle to DC
  RECT *lprc,							// pointer to rectangle structure
  unsigned int hbr				// handle to brush or a color
), int;										// returns 0 if the function fails

declare import,GetDeviceCaps(
	hdc as unsigned int,		// handle to DC
	nIndex as int						// index of capability
),int;										// returns value of the desired item

declare import, GetModuleHandleA(
	int num									
), unsigned int;

declare import,GetPixelA ALIAS GetPixel(
	hdc as unsigned int,
	x as INT,
	y as INT
),unsigned int;
declare import, GetStockObject(
  int fnObject					// stock object type
), unsigned int;				// returns handle to object, NULL if function fails

declare import, GetSysColor(
	index as int						// display element whose color is to be returned
), int;										// the RGB value

declare import, GetTextColor(
  unsigned int hdc				// gandle to DC
), unsigned int;					// returns color value or CLR_INVALID if function fails

declare import, GetTextExtentPoint32A(
	hdc as unsigned int,
	lpszStr as string,
	cbString as int,
	lpSize as POINT
), INT;

declare import, GlobalAlloc(
	int flags,							// memory allocation attributes
	int bytes								// number of bytes requested
), unsigned int;					// returns handle to memory object, NULL if function fails

declare import, GlobalFree(
  unsigned int hMem
), unsigned int;


declare import, GlobalLock(
	unsigned int handle			// handle to global memory object
), pointer;								// returns pointer to first byte, NULL if function fails

declare import, GlobalReAlloc(
  unsigned int hMem,
  unsigned int dwBytes,
  unsigned int uFlags
), unsigned int;


declare import, GlobalUnlock(
unsigned int handle				// handle to global memory object
), int;


declare import,LineToA alias LineTo(
	hdc as unsigned int,		// handle to a DC
	x as int,								// x-coordinate of ending point
	y as int								// y-coordinate of ending point
), int;										// returns 0 if function fails

declare import, LoadCursorA(
	unsigned int hModule, 				// handle to an instance of module whose executable file contains the cursor
	unsigned int lpCursorName			// To use one of the predefined cursors, set the hInstance parameter to NULL 
), unsigned int;								// returns handle to loaded cursor, NULL if function fails

declare import, LoadImageA(
	hInstance as unsigned int,
	lpszName as POINTER,
	uType as unsigned int,
	cxDesired as int,
	cydesired as int,
	fuLoad as unsigned int
), unsigned int;


declare import,LoadLibraryA(name as string),unsigned int;


declare import,lstrcpynA(
	dest as pointer,				// pointer to a buffer into which the function copies characters.
	source as pointer,			// pointer to a null-terminated string from which the function copies characters. 
	limit as int						// number of characters to be copied
),	string;								// pointer to the buffer or NULL if the function fails

declare import, MoveToEx(
  unsigned int hdc,				// handle to device context
  int x,									// x-coordinate of new current position
  int y,									// y-coordinate of new current position
  point *lpPoint					// pointer to point with old position - if set to NULL by application, not returned
), int;										// returns 0 if function fails

declare import,MulDiv(
	nNumber as int,					
	nNumerator as int,
	nDenominator as int
),int;										// returns result or, if overflow of division by zero, -1

declare import, OpenClipboard(
	unsigned int hwnd				// handle to open clipboard
), int;										// returns 0 if function fails

declare import, Rectangle(
  unsigned int hdc,				// handle to DC
  int nLeftRect,   				// x-coord of upper-left corner of rectangle
  int nTopRect,    				// y-coord of upper-left corner of rectangle
  int nRightRect,  				// x-coord of lower-right corner of rectangle
  int nBottomRect  				// y-coord of lower-right corner of rectangle
), int;										// returns 0 if function fails

declare import, SelectObject(
  unsigned int hdc,     // handle to DC
  unsigned int hgdiobj  // handle to object being selected
), unsigned int;				// handle to object being replaced, HGDI_ERROR if function fails

declare import,SendMessage alias SendMessageA(
	hwnd as unsigned int,		// handle to receiving window
	uMsg as unsigned int,		// the message
	wParam as unsigned int,	// additional info depending on message
	lParam as unsigned int	// additional info depending on message
), unsigned int;					// result depending on message

Declare import, SendMessageString  alias SendMessageA(
	hWnd As unsigned int, 
	msg As unsigned int, 
	wp As unsigned int, 
  string *lp), unsigned int;

declare import, SetBkColor
(
  unsigned int hdc,				// handle to DC
  unsigned int crColor		// background color value
), unsigned int;						// returns previous color or, if function fails, CLR_INVALID


declare import,SetBkMode(
	hdc as unsigned int,		// handle to the DC
	mode as unsigned int		// mode: TRANSPARENT or OPAQUE
), unsigned int;						// returns previous mode or 0 if function fails

declare import, SetClassLongA(
	unsigned int hwnd,			// Handle to the window and, indirectly, the class to which the window belongs. 
	int nIndex,							// Specifies the 32-bit value to replace.
	int dwNewLong						// Specifies the replacement value. 
), int;										// Returns previous value or 0 if error

declare import, SetClipboardData(
	int format,						// clipboard format
	unsigned int handle		// handle to the data
), int;									// returns handle to the data, NULL if function fails

declare import, SetCursor(
	unsigned int hCursor	// handle to the cursor; if NULL, cursor is removed from screen
), unsigned int;				// handle to previuos cursor or, if none, NULL

declare import, SetPropA(
	unsigned int hWnd,    // handle to the window whose property is added or changed
	string lpString,			// Pointer to a null-terminated string or contains an atom that identifies a string. 
	unsigned int hData		// Handle to the data to be copied to the property list.
), int;									// returns 0 if the function fails

declare import,SetPixelV(
	hdc as unsigned int,	// handle to DC
	x as int,							// x-coordinate of pixel
	y as int,							// y-coordinate of pixel
	clr as unsigned int		// color
), int;									// returns 0 if function fails

declare import, SetROP2(
  unsigned int hdc,			// handle to DC
  int fnDrawMode				// drawing mode
), int;									// returns previous mix mode, or 0 if function fails

declare import, SetTextColor(
  unsigned int hdc,     // handle to DC
  unsigned int crColor  // text color
), unsigned int;				// returns previous color of, if function fails, CLR_INVALID

declare import, SetWindowPos(
	unsigned int hwnd,						// handle of window to be repositioned
	unsigned int hwndinsertafter,	// handle of window to insert after in Z-order
	int x,												// new x-coordinate
	int y,												// new y-coordinate
	int cx,												// new width
	int cy,												// new height
	unsigned int uFlags						// flags
), int;													// returns 0 if function fails

declare import, ShellExecuteA(
	unsigned int hwnd,
	pointer lpOperation,
	pointer lpFile,
	pointer lpParameters,
	pointer lpDirectory,
	int nShowCmd
),int;

declare import,TextOutA(
unsigned int hdc, 		// handle of device context  
int nXStart, 					// x-coordinate of starting position  
int nYStart, 					// y-coordinate of starting position  
pointer lpString, 		// address of string  
int cbString  				// number of characters in string or null
), int;								// returns 0 if function fails

// TrackMouseEvents
const TME_HOVER = 1;
const TME_LEAVE = 2;
const WM_MOUSEHOVER = 0x2A1;
const WM_MOUSELEAVE = 0x2A3;

declare import,_TrackMouseEvent(tme as TRACKMOUSEEVENT),int;

struct TRACKMOUSEEVENT
{
  unsigned int cbSize;
  unsigned int dwFlags;
  unsigned int hwndTrack;
  unsigned int dwHoverTime;
}


declare import,ZeroMemory alias RtlZeroMemory(
	pvoid as pointer,		// destination
	length as int				// length in bytes
), int;
#EndIf